angular.module('aom.directives')
  .directive('aomImageEditor', function () {
    return {
      scope: {
        field: '=',
        changedMethod: '='
      },
      controller: function ($timeout, $scope, aomJobSrv, aomAttachmentsSrv, aomComponentsSrv, aomModalSrv, aomResourcesSrv) {

        $scope.funtions = {};

        $scope.data = {
          resources: aomResourcesSrv.data.resources
        };

        $scope.showCanvas = function showCanvas(field) {
          aomComponentsSrv.lockOrientation()
            .then(function () {
              var options = { Title: field.DisplayName, isField: true };
              aomAttachmentsSrv.data.attachments = field.Attachments;
              aomAttachmentsSrv.data.options = options;
              aomJobSrv.setField(field);
              $timeout(function () {
                aomModalSrv.show($scope, field.Type, field.Name);
              }, 300);
            });
        };

      },
      templateUrl: 'App/Common/Directives/ImageEditor/imageEditor.html'
    };
  });