'use strict';
angular.module('aom.directives')
  .directive('aomAnyFileThumbnail', function ($sce, $ionicModal, aomMediaSrv, aomFileSystemSrv, aomHardwareSrv) {
    return {
      scope: {
        attachment: '=',
        kind: '='
      },
      link: function ($scope) {

        function showMedia(templateUrl) {
          $ionicModal.fromTemplateUrl(templateUrl, {
            scope: $scope,
            animation: aomHardwareSrv.isTomTom() ? 'none' : 'slide-in-up'
          }).then(function (modal) {
            $scope.modal = modal;
            $scope.modal.show();
          });
        }

        $scope.fileType = aomMediaSrv.getFileType($scope.attachment.MimeType);
        $scope.shouldShow = $scope.fileType !== undefined;

        $scope.mediaListThumbnail = ionic.Platform.isAndroid() ? 'android-media-list-thumbnail' : 'media-list-thumbnail';

        $scope.video = $scope.fileType === 'video';

        if ($scope.shouldShow) {
          if ($scope.fileType === 'image') {
            $scope.imageUrl = aomFileSystemSrv.jobDataPathNormalized + $scope.attachment.filename;
          } else if ($scope.fileType === 'video') {
            $scope.videoUrl = $sce.trustAsResourceUrl(aomFileSystemSrv.jobDataPathNormalized + $scope.attachment.filename + '#t=1');
          } else {
            $scope.imageUrl = 'images/' + $scope.fileType + '.png';
          }
        }

        $scope.openFile = function ($event) {
          $event.stopPropagation();
          if ($scope.fileType === 'image') {
            showMedia('App/Common/Templates/image-popover.html');
          } else {
            aomFileSystemSrv.openSystemViewer($scope.attachment.filename, $scope.attachment.MimeType);
          }
        };

        $scope.closeModal = function () {
          $scope.modal.hide()
            .then(function () {
              $scope.modal.remove();
            })
        };

      },
      templateUrl: 'App/Common/Directives/Media/anyfilethumbnail.html'
    };
  });