angular.module('aom.directives')
  .directive('aomPhotoVideo', function () {
    return {
      scope: {
        field: '=',
        changedMethod: '='
      },
      controller: function ($scope, constants, aomAttachmentsSrv, aomJobSrv, aomPopupSrv, aomResourcesSrv, aomModalSrv) {

        $scope.data = {
          constants: constants,
          attachmentSrvData: aomAttachmentsSrv.data,
          resources: aomResourcesSrv.data.resources
        };

        function showMedia(field, options) {

          aomAttachmentsSrv.data.attachments = field.Attachments;
          aomAttachmentsSrv.data.options = options;
          aomJobSrv.setField(field);
          aomModalSrv.show($scope, field.Type, field.Name);
        }

        $scope.showAttachmentOptions = () => {
          $scope.$broadcast('AttachmentOptions');
        };

        $scope.showMediaField = (field) => {
          aomJobSrv.data.RecordDateTimeForField = field.Options.RecordDateTime;
          var options = { Title: field.DisplayName, isField: true };
          switch (field.Type) {
            case constants.fieldTypes.attachment:
              if (field.Attachments.length > 0) {
                showMedia(field, options);
              } else {
                aomPopupSrv.alert('NoAttachmentField', {
                  title: aomResourcesSrv.data.resources.Common.Error,
                  template: aomResourcesSrv.data.resources.Errors.NoAttachmentField,
                  onDismiss: function () { }
                });
              }
              break;
            case constants.fieldTypes.photoVideo:
              options.Type = field.Options.CameraType;
              showMedia(field, options);
              break;
          }
        };
      },
      templateUrl: 'App/Common/Directives/PhotoVideo/photovideo.html'
    };
  });