'use strict';
angular.module('aom.services')
  .factory('aomAuthSrv', function ($q, aomAPISrv, aomNetworkSrv) {
    var authService = {};

    authService.data = {
      authData: {},
      isReauthenticating: false
    };

    authService.logon = function (logonData) {
      if (aomNetworkSrv.onlineWithRootLinks()) {
        return aomAPISrv.postData(aomAPISrv.data.rootLinks.Login.href, logonData)
          .then(function (response) {
            if (response.status !== 200) {
              return $q.reject(response);
            } else {
              authService.data.authData = { token: response.data.access_token, userName: logonData.Username, user: response.data.User };
              aomAPISrv.data.authData = authService.data.authData;
              return $q.when(response);
            }
          });
      } else {
        return $q.when('offline');
      }
    };

    return authService;
  });