'use strict';
angular.module('aom.services')
  .factory('aomInitSrv', function ($q, $ionicPlatform, aomResourcesSrv, aomNetworkSrv, aomJobsSrv, aomAPISrv, aomGoogleMapsSrv, aomUserSrv, aomLogoutSrv, aomCustomStylesSrv) {
    var initService = {};
    initService.initialized = false;

    function initApi() {
      if (aomAPISrv.data.rootLinks === null) {
        aomAPISrv.init();
      }
      return $q.when();
    }

    function initResources() {
      if (!aomResourcesSrv.data.initialized) {
        return aomUserSrv.init();
      } else {
        return $q.when();
      }
    }

    function initJobs() {
      if (aomJobsSrv.data.jobs.length === 0) {
        return aomJobsSrv.init();
      } else {
        return $q.when();
      }
    }

    function callServiceInits() {
      if (!initService.initialized) {
        return initResources()
          .then(function () {
            return aomCustomStylesSrv.init();
          })
          .then(function () {
            aomNetworkSrv.init();
          })
          .then(function () {
            return aomGoogleMapsSrv.init();
          })
          .then(function () {
            return initJobs();
          })
          .then(function () {
            return initApi();
          })
          .then(function () {
            aomLogoutSrv.setLastActivity();
            initService.initialized = true;
          })
          .catch(function (err) {
            return $q.reject(err);
          });
      } else {
        aomLogoutSrv.setLastActivity();
        aomLogoutSrv.logoutAfter();
      }
    }

    initService.init = function () {
      if (!window.cordova) {
        return callServiceInits();
      } else {
        return $ionicPlatform.ready()
          .then(function () {
            return callServiceInits();
          });
      }
    };

    return initService;
  });