'use strict';
angular.module('aom.services')
  .factory('aomJobUpdatedSrv', function ($timeout, aomStateSrv, aomPopupSrv, aomResourcesSrv, aomJobSrv, aomTextScreenSrv, aomSelectModalSrv, constants) {
    var jobUpdatedSrv = {};

    function showDialog(popup) {
      aomSelectModalSrv.hideModal()
        .then(function () {
          return aomTextScreenSrv.hideModal();
        })
        .finally(function () {
          $timeout(function () {
            aomPopupSrv.wrapper(popup);
          }, 500);
        });
    }

    jobUpdatedSrv.shouldShowJobDeletedUpdatedDialog = function (deletedJobId) {
      return aomJobSrv.data.activeJobId === deletedJobId;
    };

    jobUpdatedSrv.showJobUpdatedDialog = function () {
      showDialog({
        id: 'updateNotificationPopup',
        title: aomResourcesSrv.data.resources.Job.JobUpdated,
        template: aomResourcesSrv.data.resources.Job.JobUpdatedNotificationMessage,
        buttons: [
          {
            text: aomResourcesSrv.data.resources.Common.Okay,
            type: 'button-positive',
            tapMethod: function () {
            }
          }
        ]
      });
    };

    jobUpdatedSrv.showJobDeletedDialog = function () {
      aomStateSrv.setRight(constants.viewStates.empty);
      showDialog({
        id: 'deleteNotificationPopup',
        title: aomResourcesSrv.data.resources.Job.JobDeleted,
        template: aomResourcesSrv.data.resources.Job.JobDeletedNotificationMessage,
        buttons: [
          {
            text: aomResourcesSrv.data.resources.Common.Okay,
            type: 'button-positive'
          }
        ]
      });

    };

    return jobUpdatedSrv;
  });