'use strict';
angular.module('aom.services')
  .factory('aomLogoutSrv', function ($timeout, $state, $rootScope, aomResourcesSrv, aomPopupSrv) {
    var logoutService = {},
      lastActivity = null,
      logoutInProgress = false,
      pendingLogout = null;

    function broadcastResumed() {
      $rootScope.$broadcast('resumed');
    }

    $rootScope.$on('resumed', function () {
      logoutService.logoutAfter();
    });

    logoutService.updateLastActivity = function() {
      logoutService.setLastActivity();
      logoutService.logoutAfter();
    };

    logoutService.setLastActivity = function () {
      lastActivity = moment();
    };

    logoutService.logoutAfter = function () {

      if (pendingLogout !== null) {
        $timeout.cancel(pendingLogout);
      }

      if (lastActivity !== null && aomResourcesSrv.data.resources.derived.SelectedTimeout.minutes !== -1 && !logoutInProgress) {
        var timeout = (aomResourcesSrv.data.resources.derived.SelectedTimeout.minutes * 60 * 1000) - moment().diff(lastActivity);

        pendingLogout = $timeout(function () {
          logoutInProgress = true;
          aomPopupSrv.closePopups();
          aomPopupSrv.closeModals();
          try {
            for (var prop in mobiscroll.instances) {
              if (mobiscroll.instances.hasOwnProperty(prop)) {
                mobiscroll.instances[prop].destroy();
              }
            }
          } catch (error) {}
          $state.go('logon');
          logoutInProgress = false;
        }, timeout);
      }
    };

    document.addEventListener('resume', function () {
      broadcastResumed('resumed');
    }, false);

    return logoutService;
  });