'use strict';
angular.module('aom.services')
  .factory('aomShareSrv', function ($q) {
    var share = {};

    share.show = function ($scope) {
      var defer = $q.defer();

      if (ionic.Platform.isAndroid() || ionic.Platform.isIOS()) {
        $scope.change = function (event) {
          if (typeof event !== 'object') {
            defer.resolve(event);
          } else {
            defer.reject(event);
          }
        };
        var fileElem = document.getElementById('fileElem');
        fileElem.click();
      } else {
        var openPicker = new Windows.Storage.Pickers.FileOpenPicker();
        openPicker.viewMode = Windows.Storage.Pickers.PickerViewMode.thumbnail;
        openPicker.suggestedStartLocation = Windows.Storage.Pickers.PickerLocationId.documentsLibrary;
        openPicker.fileTypeFilter.replaceAll(['.pdf', '.pptx', '.ppt', '.docx', '.doc', '.xls', '.xlsx']);

        openPicker.pickSingleFileAsync()
          .then(function (file) {
            if (file) {
              var storageFolder = Windows.Storage.ApplicationData.current.temporaryFolder;
              file.copyAsync(storageFolder, file.name, Windows.Storage.NameCollisionOption.replaceExisting)
                .then(function (storageFile) {
                  defer.resolve('ms-appdata:///temp/' + storageFile.name);
                })
                .catch(function () {
                  defer.reject({ name: 'Operation failed.'});    
                });
            } else {
              defer.reject({ name: 'Operation cancelled.'});
            }
          })
          .catch(function () {
            defer.reject({ name: 'Operation failed.'});                
          });
      }

      return defer.promise;
    };

    return share;
  });