'use strict';
angular.module('aom.controllers')
  .controller('MainCtrl', function ($timeout, $scope, aomResourcesSrv, constants, aomFileSystemSrv, aomStateSrv, aomJobsSrv, aomBackSrv, aomEventSrv, aomScreenSizeSrv, aomSubmitCheckSrv) {

    $scope.data = {
      resources: aomResourcesSrv.data.resources,
      resourcesData: aomResourcesSrv.data,
      stateSrvData: aomStateSrv.data,
      viewStates: constants.viewStates,
      subCheckSrvData: aomSubmitCheckSrv.data
    };

    function openSelectedJob(param) {
      $scope.$broadcast('OpenSelectedJob', param);
    }

    $scope.reloadJob = function reloadJob() {
      aomBackSrv.clear();
      $scope.$broadcast(constants.broadcastEvents.selectJob);
    };

    $scope.selectJob = function selectJob(param) {
      if (aomScreenSizeSrv.isTablet()) {
        $scope.$broadcast(constants.broadcastEvents.selectJobMarker, param);
      }
    };

    $scope.selectSetting = function selectSetting(param) {
      aomBackSrv.clear();
      $timeout(function () {
        $scope.$broadcast(constants.broadcastEvents.selectSetting, param);
      }, 100);
    };

    $scope.isShowingRightPane = function isShowingRightPane() {
      return aomStateSrv.isShowingRightPane();
    };

    $scope.updateSettingsView = function () {
      $scope.$broadcast('updateSettingsView');
    };

    $scope.$on('OpenJob', function (event, job) {
      openSelectedJob(job);
    });

    aomEventSrv.register('OpenJob', openSelectedJob);

    aomJobsSrv.jobsViewLoaded();

    $scope.$on('$destroy', function () {
      aomEventSrv.unregister('OpenJob');
    });
  });
